Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3679)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3681)
@@ -5938,34 +7310,458 @@
       ENDIF  ! ( topography /= 'flat' )
 !
-!--   Apply the reversibility correction to the boundary-normal velocity-
-!--   component v and the scalars. It must not be applied to the boundary-
-!--   tangential velocity components u and w because their 2-D anterpolation 
-!--   cells do not cover all the child-grid nodes on the boundary.
-      IF ( .NOT. ( ( var == 'u' ) .OR. ( var == 'w' ) ) )  THEN
-         m = jc(j)
-         DO  l = icl, icr
-            DO  n = 0, kct+1
+!--   Apply the reversibility correction. 
+      
+!      if  ( var == 'u' )  then
+
+      m  = jc(jbc) + moff
+      mw = 1
+!      write(9,"('pmci_interp_tril_sn: edge, var, m, j, jend, jfl(m), jfu(m) = ',2(a2,2x),5(i4,2x))") &
+!           edge, var, m, j, jend, jfl(m), jfu(m)
+!      flush(9)
+!AH      DO  l = iclw+1, icrw-1
+      DO  l = iclw + 1, icrw - lrightu   ! lrightu = 0 for u and 1 for all others
+         DO  n = 0, kct + ntopw            ! ntopw = 1 for w and 0 for all others
+            ijk = 1
+            cellsum   = 0.0_wp 
+            cellsumd  = 0.0_wp
+            DO  i = ifl(l), ifu(l)
+               iw = MAX( MIN( i, nx+1 ), -1 )
+               DO  ja = jfl(m), jfu(m)
+                  jaw = ja - j
+                  jw  = MAX( MIN( ja, ny+1 ), -1 )
+                  DO  k = kfl(n), kfu(n)
+                     kw = MIN( k, nzt+1 )
+!AH                     cellsum = cellsum + MERGE( f(k,ja,i), 0.0_wp,              &
+!AH                          BTEST( wall_flags_0(kw,jw,iw), var_flag ) )
+                     cellsum = cellsum + MERGE( workarr_sn(k,jaw,i), 0.0_wp,       &
+                          BTEST( wall_flags_0(kw,jw,iw), var_flag ) )                    
+!AH                     celltmpd(ijk) = ABS( fc(n,m,l) - f(k,ja,i) )
+!AH                     celltmpd(ijk) = ABS( workarrc_sn(n,mw,l) - f(k,ja,i) )
+                     celltmpd(ijk) = ABS( workarrc_sn(n,mw,l) - workarr_sn(k,jaw,i) )
+                     cellsumd      = cellsumd  + MERGE( celltmpd(ijk),          &
+                          0.0_wp, BTEST( wall_flags_0(kw,jw,iw), var_flag ) )
+
+!                     write(9,"('sn1: ',a1,2x,8(i4,2x),5(e12.5,2x))") var, n, m, l, k, ja, i, jaw, ijk,  &
+!                          workarrc_sn(n,mw,l), workarr_sn(k,jaw,i), cellsum, celltmpd(ijk), cellsumd
+!                     flush(9)
+
+                     ijk = ijk + 1
+                  ENDDO
+               ENDDO
+            ENDDO
+
+            IF ( ijkfc(n,m,l) /= 0 )  THEN
+               cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+!AH               rcorr     = fc(n,m,l) - cellsum
+               rcorr     = workarrc_sn(n,mw,l) - cellsum
+               cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
+            ELSE
+               cellsum   = 0.0_wp                  
+               rcorr     = 0.0_wp
+               cellsumd  = 1.0_wp
+               celltmpd  = 1.0_wp
+            ENDIF
+! 
+!--         Distribute the correction term to the child nodes according to 
+!--         their relative difference to the parent value such that the
+!--         node with the largest difference gets the largest share of the 
+!--         correction. The distribution is skipped if rcorr is negligibly 
+!--         small in order to avoid division by zero. 
+            IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
+               cellsumd  = 1.0_wp
+               celltmpd  = 1.0_wp
+            ENDIF
+            
+            ijk = 1           
+            DO  i = ifl(l), ifu(l)
+               DO  ja = jfl(m), jfu(m)
+!AH                  jaw = ja - jfl(m)
+                  jaw = ja - j
+                  DO  k = kfl(n), kfu(n)
+                     rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+!AH                     f(k,ja,i) = f(k,ja,i) + rcorr_ijk
+                     workarr_sn(k,jaw,i) = workarr_sn(k,jaw,i) + rcorr_ijk
+
+!                     write(9,"('sn2: ',a1,2x,9(i4,2x),4(e12.5,2x))") var, n, m, l, k, ja, i, jaw, ijk, ijkfc(n,m,l), &
+!                          rcorr, rcorr_ijk, workarr_sn(k,jaw,i), workarrc_sn(n,mw,l)
+!                     flush(9)
+
+                     ijk = ijk + 1
+                  ENDDO
+               ENDDO
+            ENDDO
+!
+!--         Velocity components tangential to the boundary need special 
+!--         treatment because their anterpolation cells are flat in their 
+!--         direction and hence do not cover all the child-grid boundary nodes. 
+!--         These components are next linearly interpolated to those child-grid 
+!--         boundary nodes which are not covered by the anterpolation cells.     
+            IF  ( ( var == 'w' ) .AND. ( n > 0 ) )  THEN
+               DO  k = kfu(n-1)+1, kfl(n)-1
+                  IF  ( k <= nzt )  THEN
+                     DO  i = ifl(l), ifu(l)
+                        IF  ( ( i >= nxl ) .AND. ( i <= nxr+1 ) )  THEN
+!AH                         f(k,ja,i) = r1z(k) * f(kfu(n-1),ja,i)                & 
+!AH                               + r2z(k) * f(kfl(n),ja,i)
+                           workarr_sn(k,jawbc,i) =                              &
+                                r1z(k) * workarr_sn(kfu(n-1),jawbc,i) +         & 
+                                r2z(k) * workarr_sn(kfl(n),jawbc,i)
+   
+!                           write(9,"('sn3: ',a1,2x,7(i4,2x),3(e12.5,2x))") var, n, m, l, k, jawbc, i, jbc,  &
+!                                workarr_sn(k-1,jawbc,i), workarr_sn(k,jawbc,i), workarr_sn(k+1,jawbc,i)
+!                           flush(9)
+
+                        ENDIF
+                     ENDDO
+                  ENDIF
+               ENDDO
+            ENDIF
+               
+            IF  ( ( var == 'u' ) .AND. ( l > iclw ) )  THEN
+               DO  i = ifu(l-1)+1, ifl(l)-1
+                  IF  ( ( i >= nxl ) .AND. ( i <= nxr+1 ) )  THEN
+                     DO  k = kfl(n), kfu(n)
+                        IF  ( k <= nzt+1 )  THEN
+!AH                         f(k,ja,i) = r1x(i) * f(k,ja,ifu(l-1))                &
+!AH                               + r2x(i) * f(k,ja,ifl(l))
+                           workarr_sn(k,jawbc,i) =                              &
+                                r1x(i) * workarr_sn(k,jawbc,ifu(l-1)) +         &
+                                r2x(i) * workarr_sn(k,jawbc,ifl(l))
+                           
+!                           write(9,"('sn4: ',a1,2x,7(i4,2x),3(e12.5,2x))") var, n, m, l, k, jawbc, i, jbc, &
+!                                workarr_sn(k,jawbc,i-1), workarr_sn(k,jawbc,i), workarr_sn(k,jawbc,i+1)
+!                           flush(9)
+
+                        ENDIF
+                     ENDDO
+                  ENDIF
+               ENDDO
+            ENDIF
+               
+         ENDDO  ! n
+      ENDDO  ! l 
+
+!      endif  ! var
+
+!
+!--   Finally substitute the boundary values.
+      f(nzb:nzt+1,jbc,nxl:nxr) = workarr_sn(nzb:nzt+1,jawbc,nxl:nxr)
+
+!      do  k = 0, 2
+!         do  i = nxl, nxr 
+!            if  ( edge == 's' )  then
+!               write(9,"('sn5: ',2(a2,2x),4(i4,2x),4(e12.5,2x))") edge, var, k, i, jbc, jawbc,  &
+!                    workarr_sn(k,jawbc,i), f(k,jbc,i), f(k,jbc+1,i), f(k,jbc+2,i)
+!            else if  ( edge == 'n' )  then
+!               write(9,"('sn5: ',2(a2,2x),4(i4,2x),4(e12.5,2x))") edge, var, k, i, jbc, jawbc,  &
+!                    f(k,jbc-2,i), f(k,jbc-1,i), f(k,jbc,i), workarr_sn(k,jawbc,i)
+!            endif
+!         enddo
+!      enddo
+!      flush(9)
+
+   END SUBROUTINE pmci_interp_tril_sn
+
+ 
+
+   SUBROUTINE pmci_interp_tril_t( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,       &
+                                  r1z, r2z, kct, ifl, ifu, jfl, jfu, kfl, kfu, &
+                                  ijkfc, var )
+
+!
+!--   Interpolation of ghost-node values used as the child-domain boundary
+!--   conditions. This subroutine handles the top boundary. 
+!--   This subroutine is based on trilinear interpolation.
+
+      IMPLICIT NONE
+
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                      &
+                                      INTENT(INOUT) ::  f     !< Child-grid array
+      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr),                          &
+                                      INTENT(IN)    ::  fc    !< Parent-grid array
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r1x   !<
+      REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  r2x   !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r1y   !<
+      REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  r2y   !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r1z   !<
+!AH      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  r2z   !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r1z   !<
+      REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  r2z   !<
+
+      
+      INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  ::  ic    !<
+      INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)  ::  jc    !<
+!AH      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)    ::  kc    !<
+      INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) ::  kc    !<
+
+      INTEGER(iwp) :: kct
+!AH
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+!      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
+      INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN)   ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
+!AH      INTEGER(iwp), DIMENSION(0:kct,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+!      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+      INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
+!AH
+
+      CHARACTER(LEN=1), INTENT(IN) :: var   !<
+
+      INTEGER(iwp) ::  i    !<
+      INTEGER(iwp) ::  ib   !<
+      INTEGER(iwp) ::  iclc !< Lower i-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  icrc !< Upper i-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  ie   !<
+      INTEGER(iwp) ::  ierr !< MPI error code
+      INTEGER(iwp) ::  ijk  !<
+      INTEGER(iwp) ::  iw   !<
+      INTEGER(iwp) ::  j    !<
+      INTEGER(iwp) ::  jb   !<
+      INTEGER(iwp) ::  jcsc !< Lower j-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  jcnc !< Upper j-index limit for copying fc-data to workarrc_t
+      INTEGER(iwp) ::  je   !< 
+      INTEGER(iwp) ::  jw   !<     
+      INTEGER(iwp) ::  k    !< Vertical child-grid index fixed to the boundary-value level 
+      INTEGER(iwp) ::  ka   !< Running vertical child-grid index
+      INTEGER(iwp) ::  kw   !< 
+      INTEGER(iwp) ::  l    !< Parent-grid index in x-direction
+      INTEGER(iwp) ::  lp1  !< l+1
+      INTEGER(iwp) ::  m    !< Parent-grid index in y-direction
+      INTEGER(iwp) ::  mp1  !< m+1
+      INTEGER(iwp) ::  n    !< Parent-grid work array index in z-direction
+      INTEGER(iwp) ::  np1  !< n+1
+      INTEGER(iwp) ::  noff !< n-offset needed on the top boundary to correctly refer to boundary ghost points  
+      INTEGER(iwp) ::  nw   !< n-index for workarrc_t
+      INTEGER(iwp) ::  var_flag  !<
+      
+      REAL(wp) ::  cellsum     !<
+      REAL(wp) ::  cellsumd    !<
+      REAL(wp) ::  fk          !<
+      REAL(wp) ::  fkj         !<
+      REAL(wp) ::  fkjp        !<
+      REAL(wp) ::  fkpj        !<
+      REAL(wp) ::  fkpjp       !<
+      REAL(wp) ::  fkp         !<
+      REAL(wp) ::  rcorr       !<
+      REAL(wp) ::  rcorr_ijk   !<
+
+      integer(iwp) :: kend
+
+
+      IF ( var == 'w' )  THEN
+         k    = nzt
+         noff = 0
+         kend = nzt
+      ELSE
+         k    = nzt + 1
+         noff = 1
+         kend = nzt+kgsr
+      ENDIF
+!
+!--   These exceedings by one are needed only to avoid stripes
+!--   and spots in visualization. They have no effect on the 
+!--   actual solution.     
+!
+!AH   These loop bounds lead to overflows with the current reduced icl, icr, jcs, jcn
+!AH      ib = nxl-1
+!AH      ie = nxr+1
+!AH      jb = nys-1
+!AH      je = nyn+1
+      ib = nxl
+      ie = nxr
+      jb = nys
+      je = nyn
+
+      IF ( var == 'u' )  THEN 
+         var_flag = 1 
+         ie       = nxr + 1 ! Needed for finishing interpolation for u 
+      ELSEIF ( var == 'v' )  THEN
+         var_flag = 2      
+         je       = nyn + 1 ! Needed for finishing interpolation for v 
+      ELSEIF ( var == 'w' )  THEN
+         var_flag = 3
+      ELSE
+         var_flag = 0
+      ENDIF
+         
+!AH      DO  i = ib, ie
+!AH         DO  j = jb, je
+!AH            l = ic(i)
+!AH            m = jc(j)
+!AH            n = kc(k)            
+!AH            fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
+!AH            fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
+!AH            fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
+!AH            fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
+!AH            fk       = r1y(j) * fkj  + r2y(j) * fkjp
+!AH            fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
+!AH            f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
+!AH         ENDDO
+!AH      ENDDO
+
+!      write(9,"('workarrc_t kbounds: ',a2,2x,5(i3,2x))") var, k, kend, kc(k), kc(kend), cg%nz+1
+!      flush(9)
+!AH
+!
+!--   Substitute the necessary parent-grid data to the work array. 
+!--   Note that the dimension of workarrc_t is (0:2,jcsw:jcnw,iclw:icrw),
+!--   And the jc?w and ic?w-index bounds depend on the location of the PE-
+!--   subdomain relative to the side boundaries. 
+      iclc = iclw + 1
+      icrc = icrw - 1      
+      jcsc = jcsw + 1
+      jcnc = jcnw - 1
+      IF  ( bc_dirichlet_l )  THEN
+         iclc = iclw
+      ENDIF
+      IF  ( bc_dirichlet_r )  THEN
+         icrc = icrw
+      ENDIF
+      IF  ( bc_dirichlet_s )  THEN
+         jcsc = jcsw
+      ENDIF
+      IF  ( bc_dirichlet_n )  THEN
+         jcnc = jcnw
+      ENDIF
+      workarrc_t = 0.0_wp
+      workarrc_t(0:2,jcsc:jcnc,iclc:icrc)                                       &
+           = fc(kc(k):kc(k)+2,jcsc:jcnc,iclc:icrc)
+!
+!--   Left-right exchange if more than one PE subdomain in the x-direction.
+!--   Note that in case of 3-D nesting the left and right boundaries are 
+!--   not exchanged because the nest domain is not cyclic.
+#if defined( __parallel )
+      IF  ( pdims(1) > 1 )  THEN
+!
+!--      From left to right
+         CALL MPI_SENDRECV( workarrc_t(0,jcsw,iclw+1), 1,                       &
+              workarrc_t_exchange_type_y, pleft,  0,                            &
+              workarrc_t(0,jcsw,icrw), 1,                                       &
+              workarrc_t_exchange_type_y, pright, 0,                            &
+              comm2d, status, ierr ) 
+!
+!--      From right to left        
+         CALL MPI_SENDRECV( workarrc_t(0,jcsw,icrw-1), 1,                       &
+              workarrc_t_exchange_type_y, pright, 1,                            &
+              workarrc_t(0,jcsw,iclw), 1,                                       &
+              workarrc_t_exchange_type_y, pleft,  1,                            &
+              comm2d, status, ierr )
+      ENDIF
+!
+!--   South-north exchange if more than one PE subdomain in the y-direction.
+!--   Note that in case of 3-D nesting the south and north boundaries are 
+!--   not exchanged because the nest domain is not cyclic.
+      IF  ( pdims(2) > 1 )  THEN
+!
+!--      From south to north         
+         CALL MPI_SENDRECV( workarrc_t(0,jcsw+1,iclw), 1,                       &
+              workarrc_t_exchange_type_x, psouth, 2,                            &
+              workarrc_t(0,jcnw,iclw), 1,                                       &
+              workarrc_t_exchange_type_x, pnorth, 2,                            &
+              comm2d, status, ierr ) 
+!
+!--      From north to south        
+         CALL MPI_SENDRECV( workarrc_t(0,jcnw-1,iclw), 1,                       &
+              workarrc_t_exchange_type_x, pnorth, 3,                            &
+              workarrc_t(0,jcsw,iclw), 1,                                       &
+              workarrc_t_exchange_type_x, psouth, 3,                            &
+              comm2d, status, ierr )
+      ENDIF
+#endif      
+!
+!AH
+
+      workarr_t = 0.0_wp
+
+      DO  i = ib, ie
+         DO  j = jb, je
+            DO ka = k, kend
+               l    = ic(i)
+               lp1  = MIN( l + 1, icrw ) ! If l+1 > icr (l=ic(nxr+1)), r1x = 1 and r2x = 0
+               m    = jc(j)
+               mp1  = MIN( m + 1, jcnw ) ! If m+1 > jcn (m=jc(nyn+1)), r1y = 1 and r2y = 0
+!AH
+!               n    = kc(ka)            
+               n   = kc(ka) - kc(k)
+               np1 = n + 1
+!AH
+!               fkj       = r1x(i)  * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
+!               fkjp      = r1x(i)  * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
+!               fkpj      = r1x(i)  * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
+!               fkpjp     = r1x(i)  * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
+!AH
+               fkj       = r1x(i)  * workarrc_t(n,m,l)     + r2x(i) * workarrc_t(n,m,lp1)
+               fkjp      = r1x(i)  * workarrc_t(n,mp1,l)   + r2x(i) * workarrc_t(n,mp1,lp1)
+               fkpj      = r1x(i)  * workarrc_t(np1,m,l)   + r2x(i) * workarrc_t(np1,m,lp1)
+               fkpjp     = r1x(i)  * workarrc_t(np1,mp1,l) + r2x(i) * workarrc_t(np1,mp1,lp1)
+!AH
+               fk        = r1y(j)  * fkj  + r2y(j) * fkjp
+               fkp       = r1y(j)  * fkpj + r2y(j) * fkpjp
+               workarr_t(ka,j,i) = r1z(ka) * fk + r2z(ka) * fkp
+          
+            ENDDO
+         ENDDO
+      ENDDO
+
+!AH!
+!AH!--   Just fill up the redundant second ghost-node layer for w.
+!AH      IF ( var == 'w' )  THEN
+!AH         f(nzt+1,:,:) = f(nzt,:,:)
+!AH      ENDIF
+!
+!--      Apply the reversibility correction. 
+         n  = kc(k) + noff  
+         nw = 0
+!AH         DO  l = icl-1, icr+1
+         DO  l = iclw, icrw
+!AH            DO  m = jcs-1, jcn+1
+            DO  m = jcsw, jcnw
                ijk = 1
-               cellsum   = 0.0_wp 
+               cellsum   = 0.0_wp
                cellsumd  = 0.0_wp
                DO  i = ifl(l), ifu(l)
-                  DO  ja = jfl(m), jfu(m)
-                     DO  k = kfl(n), kfu(n)
-                        cellsum = cellsum + MERGE( f(k,ja,i), 0.0_wp,           &
-                             BTEST( wall_flags_0(k,ja,i), var_flag ) )                        
-                        celltmpd(ijk) = ABS( fc(n,m,l) - f(k,ja,i) )
-                        cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
-                             0.0_wp, BTEST( wall_flags_0(k,ja,i), var_flag ) )
-                        ijk = ijk + 1
+                  iw = MAX( MIN( i, nx+1 ), -1 )
+                  IF  ( ( i >= nxl ) .AND. ( i <= nxr+1 ) )  THEN
+                     DO  j = jfl(m), jfu(m)
+                        jw = MAX( MIN( j, ny+1 ), -1 ) 
+                        IF  ( ( j >= nys ) .AND. ( j <= nyn+1 ) )  THEN
+                           DO  ka = kfl(n), kfu(n)
+                              kw = MIN( ka, nzt+1 )
+!AH                            cellsum = cellsum + MERGE( f(ka,j,i), 0.0_wp,           &
+                              cellsum = cellsum + MERGE( workarr_t(ka,j,i), 0.0_wp,   &
+                                   BTEST( wall_flags_0(kw,jw,iw), var_flag ) )
+!                              cellsum = cellsum + workarr_t(ka,j,i)
+!AH                            celltmpd(ijk) = ABS( fc(n,m,l) - f(ka,j,i) )
+!AH
+!                              celltmpd(ijk) = ABS( fc(n,m,l) - workarr_t(ka,j,i) )
+                              celltmpd(ijk) = ABS( workarrc_t(nw,m,l) - workarr_t(ka,j,i) )
+!AH
+                              cellsumd      = cellsumd  + MERGE( celltmpd(ijk),       &
+                                   0.0_wp, BTEST( wall_flags_0(kw,jw,iw), var_flag ) ) 
+                              ijk = ijk + 1
+                           ENDDO
+                        ENDIF
                      ENDDO
-                  ENDDO
+                  ENDIF
                ENDDO
 
                IF ( ijkfc(n,m,l) /= 0 )  THEN
                   cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
-                  rcorr     = fc(n,m,l) - cellsum
+!AH
+!                  rcorr     = fc(n,m,l) - cellsum
+                  rcorr     = workarrc_t(nw,m,l) - cellsum
+!AH                  
                   cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
                ELSE
-                  cellsum   = 0.0_wp                  
+                  cellsum   = 0.0_wp
                   rcorr     = 0.0_wp
                   cellsumd  = 1.0_wp
